import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateStackSetInput, CreateStackSetOutput } from "../models/models_0";
import { deserializeAws_queryCreateStackSetCommand, serializeAws_queryCreateStackSetCommand, } from "../protocols/Aws_query";
var CreateStackSetCommand = (function (_super) {
    __extends(CreateStackSetCommand, _super);
    function CreateStackSetCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateStackSetCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "CreateStackSetCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateStackSetInput.filterSensitiveLog,
            outputFilterSensitiveLog: CreateStackSetOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateStackSetCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCreateStackSetCommand(input, context);
    };
    CreateStackSetCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCreateStackSetCommand(output, context);
    };
    return CreateStackSetCommand;
}($Command));
export { CreateStackSetCommand };
