import { EndpointsInputConfig, EndpointsResolvedConfig, RegionInputConfig, RegionResolvedConfig } from "@aws-sdk/config-resolver";
import { HostHeaderInputConfig, HostHeaderResolvedConfig } from "@aws-sdk/middleware-host-header";
import { RetryInputConfig, RetryResolvedConfig } from "@aws-sdk/middleware-retry";
import { AwsAuthInputConfig, AwsAuthResolvedConfig } from "@aws-sdk/middleware-signing";
import { UserAgentInputConfig, UserAgentResolvedConfig } from "@aws-sdk/middleware-user-agent";
import { HttpHandler as __HttpHandler } from "@aws-sdk/protocol-http";
import { Client as __Client, DefaultsMode, SmithyConfiguration as __SmithyConfiguration, SmithyResolvedConfiguration as __SmithyResolvedConfiguration } from "@aws-sdk/smithy-client";
import { BodyLengthCalculator as __BodyLengthCalculator, Credentials as __Credentials, Decoder as __Decoder, Encoder as __Encoder, HashConstructor as __HashConstructor, HttpHandlerOptions as __HttpHandlerOptions, Logger as __Logger, Provider as __Provider, Provider, RegionInfoProvider, StreamCollector as __StreamCollector, UrlParser as __UrlParser, UserAgent as __UserAgent } from "@aws-sdk/types";
import { ActivateTypeCommandInput, ActivateTypeCommandOutput } from "./commands/ActivateTypeCommand";
import { BatchDescribeTypeConfigurationsCommandInput, BatchDescribeTypeConfigurationsCommandOutput } from "./commands/BatchDescribeTypeConfigurationsCommand";
import { CancelUpdateStackCommandInput, CancelUpdateStackCommandOutput } from "./commands/CancelUpdateStackCommand";
import { ContinueUpdateRollbackCommandInput, ContinueUpdateRollbackCommandOutput } from "./commands/ContinueUpdateRollbackCommand";
import { CreateChangeSetCommandInput, CreateChangeSetCommandOutput } from "./commands/CreateChangeSetCommand";
import { CreateStackCommandInput, CreateStackCommandOutput } from "./commands/CreateStackCommand";
import { CreateStackInstancesCommandInput, CreateStackInstancesCommandOutput } from "./commands/CreateStackInstancesCommand";
import { CreateStackSetCommandInput, CreateStackSetCommandOutput } from "./commands/CreateStackSetCommand";
import { DeactivateTypeCommandInput, DeactivateTypeCommandOutput } from "./commands/DeactivateTypeCommand";
import { DeleteChangeSetCommandInput, DeleteChangeSetCommandOutput } from "./commands/DeleteChangeSetCommand";
import { DeleteStackCommandInput, DeleteStackCommandOutput } from "./commands/DeleteStackCommand";
import { DeleteStackInstancesCommandInput, DeleteStackInstancesCommandOutput } from "./commands/DeleteStackInstancesCommand";
import { DeleteStackSetCommandInput, DeleteStackSetCommandOutput } from "./commands/DeleteStackSetCommand";
import { DeregisterTypeCommandInput, DeregisterTypeCommandOutput } from "./commands/DeregisterTypeCommand";
import { DescribeAccountLimitsCommandInput, DescribeAccountLimitsCommandOutput } from "./commands/DescribeAccountLimitsCommand";
import { DescribeChangeSetCommandInput, DescribeChangeSetCommandOutput } from "./commands/DescribeChangeSetCommand";
import { DescribeChangeSetHooksCommandInput, DescribeChangeSetHooksCommandOutput } from "./commands/DescribeChangeSetHooksCommand";
import { DescribePublisherCommandInput, DescribePublisherCommandOutput } from "./commands/DescribePublisherCommand";
import { DescribeStackDriftDetectionStatusCommandInput, DescribeStackDriftDetectionStatusCommandOutput } from "./commands/DescribeStackDriftDetectionStatusCommand";
import { DescribeStackEventsCommandInput, DescribeStackEventsCommandOutput } from "./commands/DescribeStackEventsCommand";
import { DescribeStackInstanceCommandInput, DescribeStackInstanceCommandOutput } from "./commands/DescribeStackInstanceCommand";
import { DescribeStackResourceCommandInput, DescribeStackResourceCommandOutput } from "./commands/DescribeStackResourceCommand";
import { DescribeStackResourceDriftsCommandInput, DescribeStackResourceDriftsCommandOutput } from "./commands/DescribeStackResourceDriftsCommand";
import { DescribeStackResourcesCommandInput, DescribeStackResourcesCommandOutput } from "./commands/DescribeStackResourcesCommand";
import { DescribeStacksCommandInput, DescribeStacksCommandOutput } from "./commands/DescribeStacksCommand";
import { DescribeStackSetCommandInput, DescribeStackSetCommandOutput } from "./commands/DescribeStackSetCommand";
import { DescribeStackSetOperationCommandInput, DescribeStackSetOperationCommandOutput } from "./commands/DescribeStackSetOperationCommand";
import { DescribeTypeCommandInput, DescribeTypeCommandOutput } from "./commands/DescribeTypeCommand";
import { DescribeTypeRegistrationCommandInput, DescribeTypeRegistrationCommandOutput } from "./commands/DescribeTypeRegistrationCommand";
import { DetectStackDriftCommandInput, DetectStackDriftCommandOutput } from "./commands/DetectStackDriftCommand";
import { DetectStackResourceDriftCommandInput, DetectStackResourceDriftCommandOutput } from "./commands/DetectStackResourceDriftCommand";
import { DetectStackSetDriftCommandInput, DetectStackSetDriftCommandOutput } from "./commands/DetectStackSetDriftCommand";
import { EstimateTemplateCostCommandInput, EstimateTemplateCostCommandOutput } from "./commands/EstimateTemplateCostCommand";
import { ExecuteChangeSetCommandInput, ExecuteChangeSetCommandOutput } from "./commands/ExecuteChangeSetCommand";
import { GetStackPolicyCommandInput, GetStackPolicyCommandOutput } from "./commands/GetStackPolicyCommand";
import { GetTemplateCommandInput, GetTemplateCommandOutput } from "./commands/GetTemplateCommand";
import { GetTemplateSummaryCommandInput, GetTemplateSummaryCommandOutput } from "./commands/GetTemplateSummaryCommand";
import { ImportStacksToStackSetCommandInput, ImportStacksToStackSetCommandOutput } from "./commands/ImportStacksToStackSetCommand";
import { ListChangeSetsCommandInput, ListChangeSetsCommandOutput } from "./commands/ListChangeSetsCommand";
import { ListExportsCommandInput, ListExportsCommandOutput } from "./commands/ListExportsCommand";
import { ListImportsCommandInput, ListImportsCommandOutput } from "./commands/ListImportsCommand";
import { ListStackInstancesCommandInput, ListStackInstancesCommandOutput } from "./commands/ListStackInstancesCommand";
import { ListStackResourcesCommandInput, ListStackResourcesCommandOutput } from "./commands/ListStackResourcesCommand";
import { ListStacksCommandInput, ListStacksCommandOutput } from "./commands/ListStacksCommand";
import { ListStackSetOperationResultsCommandInput, ListStackSetOperationResultsCommandOutput } from "./commands/ListStackSetOperationResultsCommand";
import { ListStackSetOperationsCommandInput, ListStackSetOperationsCommandOutput } from "./commands/ListStackSetOperationsCommand";
import { ListStackSetsCommandInput, ListStackSetsCommandOutput } from "./commands/ListStackSetsCommand";
import { ListTypeRegistrationsCommandInput, ListTypeRegistrationsCommandOutput } from "./commands/ListTypeRegistrationsCommand";
import { ListTypesCommandInput, ListTypesCommandOutput } from "./commands/ListTypesCommand";
import { ListTypeVersionsCommandInput, ListTypeVersionsCommandOutput } from "./commands/ListTypeVersionsCommand";
import { PublishTypeCommandInput, PublishTypeCommandOutput } from "./commands/PublishTypeCommand";
import { RecordHandlerProgressCommandInput, RecordHandlerProgressCommandOutput } from "./commands/RecordHandlerProgressCommand";
import { RegisterPublisherCommandInput, RegisterPublisherCommandOutput } from "./commands/RegisterPublisherCommand";
import { RegisterTypeCommandInput, RegisterTypeCommandOutput } from "./commands/RegisterTypeCommand";
import { RollbackStackCommandInput, RollbackStackCommandOutput } from "./commands/RollbackStackCommand";
import { SetStackPolicyCommandInput, SetStackPolicyCommandOutput } from "./commands/SetStackPolicyCommand";
import { SetTypeConfigurationCommandInput, SetTypeConfigurationCommandOutput } from "./commands/SetTypeConfigurationCommand";
import { SetTypeDefaultVersionCommandInput, SetTypeDefaultVersionCommandOutput } from "./commands/SetTypeDefaultVersionCommand";
import { SignalResourceCommandInput, SignalResourceCommandOutput } from "./commands/SignalResourceCommand";
import { StopStackSetOperationCommandInput, StopStackSetOperationCommandOutput } from "./commands/StopStackSetOperationCommand";
import { TestTypeCommandInput, TestTypeCommandOutput } from "./commands/TestTypeCommand";
import { UpdateStackCommandInput, UpdateStackCommandOutput } from "./commands/UpdateStackCommand";
import { UpdateStackInstancesCommandInput, UpdateStackInstancesCommandOutput } from "./commands/UpdateStackInstancesCommand";
import { UpdateStackSetCommandInput, UpdateStackSetCommandOutput } from "./commands/UpdateStackSetCommand";
import { UpdateTerminationProtectionCommandInput, UpdateTerminationProtectionCommandOutput } from "./commands/UpdateTerminationProtectionCommand";
import { ValidateTemplateCommandInput, ValidateTemplateCommandOutput } from "./commands/ValidateTemplateCommand";
export declare type ServiceInputTypes = ActivateTypeCommandInput | BatchDescribeTypeConfigurationsCommandInput | CancelUpdateStackCommandInput | ContinueUpdateRollbackCommandInput | CreateChangeSetCommandInput | CreateStackCommandInput | CreateStackInstancesCommandInput | CreateStackSetCommandInput | DeactivateTypeCommandInput | DeleteChangeSetCommandInput | DeleteStackCommandInput | DeleteStackInstancesCommandInput | DeleteStackSetCommandInput | DeregisterTypeCommandInput | DescribeAccountLimitsCommandInput | DescribeChangeSetCommandInput | DescribeChangeSetHooksCommandInput | DescribePublisherCommandInput | DescribeStackDriftDetectionStatusCommandInput | DescribeStackEventsCommandInput | DescribeStackInstanceCommandInput | DescribeStackResourceCommandInput | DescribeStackResourceDriftsCommandInput | DescribeStackResourcesCommandInput | DescribeStackSetCommandInput | DescribeStackSetOperationCommandInput | DescribeStacksCommandInput | DescribeTypeCommandInput | DescribeTypeRegistrationCommandInput | DetectStackDriftCommandInput | DetectStackResourceDriftCommandInput | DetectStackSetDriftCommandInput | EstimateTemplateCostCommandInput | ExecuteChangeSetCommandInput | GetStackPolicyCommandInput | GetTemplateCommandInput | GetTemplateSummaryCommandInput | ImportStacksToStackSetCommandInput | ListChangeSetsCommandInput | ListExportsCommandInput | ListImportsCommandInput | ListStackInstancesCommandInput | ListStackResourcesCommandInput | ListStackSetOperationResultsCommandInput | ListStackSetOperationsCommandInput | ListStackSetsCommandInput | ListStacksCommandInput | ListTypeRegistrationsCommandInput | ListTypeVersionsCommandInput | ListTypesCommandInput | PublishTypeCommandInput | RecordHandlerProgressCommandInput | RegisterPublisherCommandInput | RegisterTypeCommandInput | RollbackStackCommandInput | SetStackPolicyCommandInput | SetTypeConfigurationCommandInput | SetTypeDefaultVersionCommandInput | SignalResourceCommandInput | StopStackSetOperationCommandInput | TestTypeCommandInput | UpdateStackCommandInput | UpdateStackInstancesCommandInput | UpdateStackSetCommandInput | UpdateTerminationProtectionCommandInput | ValidateTemplateCommandInput;
export declare type ServiceOutputTypes = ActivateTypeCommandOutput | BatchDescribeTypeConfigurationsCommandOutput | CancelUpdateStackCommandOutput | ContinueUpdateRollbackCommandOutput | CreateChangeSetCommandOutput | CreateStackCommandOutput | CreateStackInstancesCommandOutput | CreateStackSetCommandOutput | DeactivateTypeCommandOutput | DeleteChangeSetCommandOutput | DeleteStackCommandOutput | DeleteStackInstancesCommandOutput | DeleteStackSetCommandOutput | DeregisterTypeCommandOutput | DescribeAccountLimitsCommandOutput | DescribeChangeSetCommandOutput | DescribeChangeSetHooksCommandOutput | DescribePublisherCommandOutput | DescribeStackDriftDetectionStatusCommandOutput | DescribeStackEventsCommandOutput | DescribeStackInstanceCommandOutput | DescribeStackResourceCommandOutput | DescribeStackResourceDriftsCommandOutput | DescribeStackResourcesCommandOutput | DescribeStackSetCommandOutput | DescribeStackSetOperationCommandOutput | DescribeStacksCommandOutput | DescribeTypeCommandOutput | DescribeTypeRegistrationCommandOutput | DetectStackDriftCommandOutput | DetectStackResourceDriftCommandOutput | DetectStackSetDriftCommandOutput | EstimateTemplateCostCommandOutput | ExecuteChangeSetCommandOutput | GetStackPolicyCommandOutput | GetTemplateCommandOutput | GetTemplateSummaryCommandOutput | ImportStacksToStackSetCommandOutput | ListChangeSetsCommandOutput | ListExportsCommandOutput | ListImportsCommandOutput | ListStackInstancesCommandOutput | ListStackResourcesCommandOutput | ListStackSetOperationResultsCommandOutput | ListStackSetOperationsCommandOutput | ListStackSetsCommandOutput | ListStacksCommandOutput | ListTypeRegistrationsCommandOutput | ListTypeVersionsCommandOutput | ListTypesCommandOutput | PublishTypeCommandOutput | RecordHandlerProgressCommandOutput | RegisterPublisherCommandOutput | RegisterTypeCommandOutput | RollbackStackCommandOutput | SetStackPolicyCommandOutput | SetTypeConfigurationCommandOutput | SetTypeDefaultVersionCommandOutput | SignalResourceCommandOutput | StopStackSetOperationCommandOutput | TestTypeCommandOutput | UpdateStackCommandOutput | UpdateStackInstancesCommandOutput | UpdateStackSetCommandOutput | UpdateTerminationProtectionCommandOutput | ValidateTemplateCommandOutput;
export interface ClientDefaults extends Partial<__SmithyResolvedConfiguration<__HttpHandlerOptions>> {
    
    requestHandler?: __HttpHandler;
    
    sha256?: __HashConstructor;
    
    urlParser?: __UrlParser;
    
    bodyLengthChecker?: __BodyLengthCalculator;
    
    streamCollector?: __StreamCollector;
    
    base64Decoder?: __Decoder;
    
    base64Encoder?: __Encoder;
    
    utf8Decoder?: __Decoder;
    
    utf8Encoder?: __Encoder;
    
    runtime?: string;
    
    disableHostPrefix?: boolean;
    
    maxAttempts?: number | __Provider<number>;
    
    retryMode?: string | __Provider<string>;
    
    logger?: __Logger;
    
    useDualstackEndpoint?: boolean | __Provider<boolean>;
    
    useFipsEndpoint?: boolean | __Provider<boolean>;
    
    serviceId?: string;
    
    region?: string | __Provider<string>;
    
    credentialDefaultProvider?: (input: any) => __Provider<__Credentials>;
    
    regionInfoProvider?: RegionInfoProvider;
    
    defaultUserAgentProvider?: Provider<__UserAgent>;
    
    defaultsMode?: DefaultsMode | Provider<DefaultsMode>;
}
declare type CloudFormationClientConfigType = Partial<__SmithyConfiguration<__HttpHandlerOptions>> & ClientDefaults & RegionInputConfig & EndpointsInputConfig & RetryInputConfig & HostHeaderInputConfig & AwsAuthInputConfig & UserAgentInputConfig;

export interface CloudFormationClientConfig extends CloudFormationClientConfigType {
}
declare type CloudFormationClientResolvedConfigType = __SmithyResolvedConfiguration<__HttpHandlerOptions> & Required<ClientDefaults> & RegionResolvedConfig & EndpointsResolvedConfig & RetryResolvedConfig & HostHeaderResolvedConfig & AwsAuthResolvedConfig & UserAgentResolvedConfig;

export interface CloudFormationClientResolvedConfig extends CloudFormationClientResolvedConfigType {
}

export declare class CloudFormationClient extends __Client<__HttpHandlerOptions, ServiceInputTypes, ServiceOutputTypes, CloudFormationClientResolvedConfig> {
    
    readonly config: CloudFormationClientResolvedConfig;
    constructor(configuration: CloudFormationClientConfig);
    
    destroy(): void;
}
export {};
