import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { CancelUpdateStackInput } from "../models/models_0";
export interface CancelUpdateStackCommandInput extends CancelUpdateStackInput {
}
export interface CancelUpdateStackCommandOutput extends __MetadataBearer {
}

export declare class CancelUpdateStackCommand extends $Command<CancelUpdateStackCommandInput, CancelUpdateStackCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: CancelUpdateStackCommandInput;
    constructor(input: CancelUpdateStackCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CancelUpdateStackCommandInput, CancelUpdateStackCommandOutput>;
    private serialize;
    private deserialize;
}
