import clean from './_clean';
import flatten from './_flatten';
import isObjectEmpty from './_isObjectEmpty';
export var resetSubmitErrors = function (_a, state, _b) {
    var _c = _a[0], prev = _c.prev, current = _c.current;
    var getIn = _b.getIn, setIn = _b.setIn;
    // Reset the general submit error on any value change
    if (state.formState.submitError) {
        delete state.formState.submitError;
    }
    if (!isObjectEmpty(state.formState.submitErrors)) {
        // Flatten nested errors object for easier comparison
        var flatErrors = flatten(state.formState.submitErrors);
        var changed_1 = [];
        // Iterate over each error
        Object.keys(flatErrors).forEach(function (key) {
            // Compare the value for the error field path
            if (getIn(prev, key) !== getIn(current, key)) {
                changed_1.push(key);
            }
        });
        // Reset the error on value change
        if (changed_1.length) {
            var newErrors_1 = state.formState.submitErrors;
            changed_1.forEach(function (key) {
                newErrors_1 = setIn(newErrors_1, key, null);
            });
            // Clear submit errors from empty objects and arrays
            var cleanErrors = clean(newErrors_1);
            state.formState.submitErrors = cleanErrors;
        }
    }
};
export default {
    resetSubmitErrors: resetSubmitErrors
};
